package com.example.kdan_data_center.datacenter.share.data

import com.google.gson.annotations.SerializedName

data class CreateShareLinkData(
        @SerializedName("data")
        val `data`: Data,
        @SerializedName("message")
        val message: String
) {
    data class Data(
            @SerializedName("access_check")
            val accessCheck: AccessCheck,
            @SerializedName("app_bundle_id")
            val appBundleId: String,
            @SerializedName("app_id")
            val appId: Int?,
            @SerializedName("created_at")
            val createdAt: String,
            @SerializedName("expires_at")
            val expiresAt: String?,
            @SerializedName("id")
            val id: Int,
            @SerializedName("is_alive")
            val isAlive: Boolean,
            @SerializedName("link_url")
            val linkUrl: String,
            @SerializedName("mission_id")
            val missionId: Int,
            @SerializedName("preview_token")
            val previewToken: String,
            @SerializedName("shareable_id")
            val shareableId: Int,
            @SerializedName("shareable_info")
            val shareableInfo: ShareableInfo,
            @SerializedName("shareable_type")
            val shareableType: String,
            @SerializedName("status")
            val status: String,
            @SerializedName("updated_at")
            val updatedAt: String,
            @SerializedName("url_token")
            val urlToken: String,
            @SerializedName("user_id")
            val userId: Int,
            @SerializedName("user_id_backup")
            val userIdBackup: Int?,
            @SerializedName("verify_data")
            val verifyData: VerifyData,
            @SerializedName("verify_info")
            val verifyInfo: String?,
            @SerializedName("verify_type")
            val verifyType: String
    ) {
        data class VerifyData(
                @SerializedName("owner")
                val owner: String
        )

        data class AccessCheck(
                @SerializedName("allow_action")
                val allowAction: String,
                @SerializedName("verify_type")
                val verifyType: String
        )

        data class ShareableInfo(
                @SerializedName("download_url")
                val downloadUrl: String,
                @SerializedName("file_ready")
                val fileReady: Boolean,
                @SerializedName("shareable_detail")
                val shareableDetail: ShareableDetail,
                @SerializedName("shareable_exists")
                val shareableExists: Boolean,
                @SerializedName("viewer")
                val viewer: String
        ) {
            data class ShareableDetail(
                    @SerializedName("active_status")
                    val activeStatus: String,
                    @SerializedName("app_bundle_id")
                    val appBundleId: String,
                    @SerializedName("app_foreign_id")
                    val appForeignId: Int,
                    @SerializedName("app_id")
                    val appId: Int,
                    @SerializedName("auth")
                    val auth: String?,
                    @SerializedName("bucket_id")
                    val bucketId: Int,
                    @SerializedName("bucket_name")
                    val bucketName: String,
                    @SerializedName("category")
                    val category: String,
                    @SerializedName("compress_url")
                    val compressUrl: HashMap<String,String>,
                    @SerializedName("cover_name")
                    val coverName: String?,
                    @SerializedName("created_at")
                    val createdAt: String,
                    @SerializedName("current_app_version")
                    val currentAppVersion: Int,
                    @SerializedName("current_version")
                    val currentVersion: String,
                    @SerializedName("data_format_version")
                    val dataFormatVersion: Int,
                    @SerializedName("folder_id")
                    val folderId: Int,
                    @SerializedName("has_zipfile")
                    val hasZipfile: Boolean,
                    @SerializedName("id")
                    val id: Int,
                    @SerializedName("is_converted_file")
                    val isConvertedFile: Boolean,
                    @SerializedName("is_deleted")
                    val isDeleted: Boolean,
                    @SerializedName("is_download_file_ready")
                    val isDownloadFileReady: Boolean,
                    @SerializedName("mainfile_key")
                    val mainfileKey: String,
                    @SerializedName("object_type")
                    val objectType: String,
                    @SerializedName("other_infos")
                    val otherInfos: HashMap<String,String>,
                    @SerializedName("owner_id")
                    val ownerId: Int,
                    @SerializedName("password_protected")
                    val passwordProtected: Boolean?,
                    @SerializedName("path_string")
                    val pathString: String,
                    @SerializedName("platform")
                    val platform: String?,
                    @SerializedName("project_created_at")
                    val projectCreatedAt: String?,
                    @SerializedName("project_id")
                    val projectId: String,
                    @SerializedName("project_name")
                    val projectName: String,
                    @SerializedName("project_type")
                    val projectType: String?,
                    @SerializedName("short_url")
                    val shortUrl: String?,
                    @SerializedName("size")
                    val size: Int,
                    @SerializedName("sort_priority")
                    val sortPriority: Int,
                    @SerializedName("status")
                    val status: String,
                    @SerializedName("tag_sample")
                    val tagSample: ArrayList<String>?,
                    @SerializedName("thumbnail_url")
                    val thumbnailUrl: ThumbnailUrl,
                    @SerializedName("unit_token")
                    val unitToken: String,
                    @SerializedName("updated_at")
                    val updatedAt: String,
                    @SerializedName("uploader")
                    val uploader: Uploader,
                    @SerializedName("uploader_id")
                    val uploaderId: Int,
                    @SerializedName("uploader_type")
                    val uploaderType: String,
                    @SerializedName("url")
                    val url: String?,
                    @SerializedName("url_created_at")
                    val urlCreatedAt: String?,
                    @SerializedName("user_id")
                    val userId: Int,
                    @SerializedName("user_id_backup")
                    val userIdBackup: Int?,
                    @SerializedName("user_updated_at")
                    val userUpdatedAt: String,
                    @SerializedName("version")
                    val version: Int?
            ) {
                data class ThumbnailUrl(
                        @SerializedName("cover_175")
                        val cover175: String,
                        @SerializedName("cover_275")
                        val cover275: String,
                        @SerializedName("cover_50")
                        val cover50: String
                )

                data class Uploader(
                        @SerializedName("account")
                        val account: String,
                        @SerializedName("email")
                        val email: String,
                        @SerializedName("folder_name_hash")
                        val folderNameHash: String,
                        @SerializedName("full_storage")
                        val fullStorage: Int,
                        @SerializedName("icon_url")
                        val iconUrl: IconUrl,
                        @SerializedName("id")
                        val id: Int,
                        @SerializedName("name")
                        val name: String,
                        @SerializedName("uid")
                        val uid: Int,
                        @SerializedName("used_storage")
                        val usedStorage: Int
                ) {
                    data class IconUrl(
                            @SerializedName("100")
                            val x100: String,
                            @SerializedName("280")
                            val x280: String
                    )
                }
            }
        }
    }
}